module VueCK
    class BatchRenderer
        def initialize(opts={})
            @path = opts[:path] || DIRS[:components]
        end

        def render
            out = {components:"",style:""}
            file_iterator do |file|
                component = SFC.new file
                out[:components] += component.render_component
                out[:style]      += component.render_style
            end
            out
        end

        private

        def file_iterator(&block)
            Dir.glob("#{@path}*.vue") do |item|
                next if item == '.' or item == '..'
                yield item
            end
        end
    end
end