module VueCK
    class Plugin
        REQUEST_MAP = {
            "/vue/vue.js" => {
                file: "vue.js",
                content_type: "application/javascript"
            },
            "/vue/vue.css" => {
                file: "vue.css",
                content_type: "text/css"
            }
        }

        def initialize(app={})
            @app = app
        end
        
        def call(env)
            return @app.call(env) unless env["REQUEST_METHOD"] == "GET"
            path = env["PATH_INFO"]
            return @app.call(env) unless REQUEST_MAP[path]
            vueck = VueCK.new REQUEST_MAP[path][:file]
            content = vueck.serve_file
            response(content, path)
        end

        def response(content, path)
            ["200", {
                "Content-Type"   => REQUEST_MAP[path][:content_type],
                "Content-Length" => content.size.to_s },
                [content]]
        end

    end
end