module VueCK
    class SFC
        attr_accessor :xml, :script, :style, :template, :name

        def initialize(component_file)
            @path = component_file
            @xml  = component_xml
            @name = @xml.attribute(ATTRIBUTES[:name]).value
        end

        def render_component
            reduce_whitespace "var #{@name} = Vue.component('#{@name}',{template:'#{render(:template)}', #{render(:script)}});"
        end

        def render_style
            style = Element.new(@xml, :style)
            return "" if style.empty?
            CSSminify.compress reduce_whitespace(style.render)
        end

        private

        def reduce_whitespace(text)
            text.gsub(/\s+/, " ")
        end

        def load
            Oga.parse_xml File.open @path
        end

        def component_xml
            load.css(ELEMENTS[:component]).first
        end

        def render(type)
            Element.new(@xml, type).render
        end

    end
end